﻿function buytoweixin(payitem) {
	if(userbind!=1){
		myAlert("账号信息尚未完善，请先完善再进行支付！");
		goTo("duanxian_userbind.html");
		return;
	}
	var isagree = $("#agree").is(":checked");
	if(isagree){
		checkuser();
		showLoading();
	
		if (parseInt(payitem) > 10) {
			$("#pointsintrobBox").css("display", "none");
		} else {
			$("#vipbox").css("display", "none");
		}
		var params = {
			userid: userid,
			payitem: payitem,
			appitem: 'duanxian'
		};
		$.ajax({
			async: false,
			url: serverURL + '/jsonp_payonline_weixin.asp', // 跨域URL
			type: 'get',
			dataType: 'jsonp',
			jsonp: 'jsoncallback', //默认callback
			data: params,
			timeout: 5000,
			beforeSend: function () { //jsonp 方式此方法不被触发。原因可能是dataType如果指定为jsonp的话，就已经不是ajax事件了
			},
			success: function (json) { //客户端jquery预先定义好的callback函数，成功获取跨域服务器上的json数据后，会动态执行这个callback函数 
				hideLoading();
				if (parseInt(payitem) > 10) {
					$("#pointsintrobBox").css("display", "block");
				} else {
					$("#vipbox").css("display", "block");
				}
	
				//alert(json.prepayid);
				var params = {
					appid: json.appid,// appId
					partnerid: json.partnerid, // merchant id
					prepayid: json.prepayid, // prepay id
					noncestr: json.noncestr, // nonce
					package: json.package, // package
					timestamp: json.timestamp, // timestamp
					sign: json.sign // signed string
				};
	
				Wechat.sendPaymentRequest(params, function () {
					myAlert("支付成功，谢谢！");
					if (parseInt(payitem) > 10) {//购买金币
						myuser();
					} else {
						goTo('duanxian_vipwelcome.html');
					}
				}, function (reason) {
					myAlert("支付失败: " + reason);
				});
			},
			complete: function (XMLHttpRequest, textStatus) {
			},
			error: function (xhr) {
				hideLoading();
				//jsonp 方式此方法不被触发
				//请求出错处理 
				myAlert("请求出错(请检查相关度网络状况.)");
				if (parseInt(payitem) > 10) {
					$("#pointsintrobBox").css("display", "block");
				} else {
					$("#vipbox").css("display", "block");
				}
			}
		});
	}else{
		myAlert("同意我们的云智软件收费服务协议才能开通贵宾服务");
	}
}
function buytoalipay(payitem) {
	if(userbind!=1){
		myAlert("账号信息尚未完善，请先完善再进行支付！");
		goTo("duanxian_userbind.html");
		return;
	}
	var isagree = $("#agree").is(":checked");
	if(isagree){
		checkuser();
		showLoading();
		if (parseInt(payitem) > 10) {
			$("#pointsintrobBox").css("display", "none");
		} else {
			$("#vipbox").css("display", "none");
		}
		var params = {
			userid: userid,
			payitem: payitem,
			appitem: 'duanxian'
		};
		$.ajax({
			async: false,
			url: serverURL + '/jsonp_payonline.asp', // 跨域URL
			type: 'get',
			dataType: 'jsonp',
			jsonp: 'jsoncallback', //默认callback
			data: params,
			timeout: 5000,
			beforeSend: function () { //jsonp 方式此方法不被触发。原因可能是dataType如果指定为jsonp的话，就已经不是ajax事件了
			},
			success: function (json) { //客户端jquery预先定义好的callback函数，成功获取跨域服务器上的json数据后，会动态执行这个callback函数 
				hideLoading();
				if (parseInt(payitem) > 10) {
					$("#pointsintrobBox").css("display", "block");
				} else {
					$("#vipbox").css("display", "block");
				}
				var strHtml = "";
				var jsonObject = eval("(" + json + ")");
				if (jsonObject.isok == "ok") {
					cordova.plugins.alipay.payment(jsonObject.payinfostr, function success(e) {
						if (e.resultStatus == 9000) {
							myAlert("支付成功，谢谢！");
							if (parseInt(payitem) > 10) {//购买金币
								myuser();
							} else {
								goTo('duanxian_vipwelcome.html');
							}
						} else {
							myAlert("抱歉，支付不成功！");
						}
					}, function error(e) { myAlert("抱歉，支付不成功！"); });
				} else {
					myAlert(jsonObject.str);
				}
	
			},
			complete: function (XMLHttpRequest, textStatus) {
			},
			error: function (xhr) {
				hideLoading();
				//jsonp 方式此方法不被触发
				//请求出错处理 
				myAlert("请求出错(请检查相关度网络状况.)");
				if (parseInt(payitem) > 10) {
					$("#pointsintrobBox").css("display", "block");
				} else {
					$("#vipbox").css("display", "block");
				}
			}
		});
	}else{
		myAlert("同意我们的云智软件收费服务协议才能开通贵宾服务");
	}
}
