﻿function startRecordAudio(){
	// 开始录制音频
	$("#voiceImg").attr("src","./images/duanxian/mic.gif");
	mediaRec = new Media(src,onmediaSuccess, onmediaError); 
	mediaRec.startRecord(); 
	voiceTimer = 0; 
	recInterval = setInterval(function() { 
		voiceTimer++;  
		var processbarLength = processbgLength*voiceTimer/60;
		$("#processbar").width(processbarLength);
		if(voiceTimer==60){
			stopRecordAudio();
		}
	}, 1000); 
	$("#voice_cancel").css("display","none");
	$("#voice_Record").css("display","none");
	$("#voice_stopRecord").css("display","block");
	$("#voice_delete").css("display","none");
};
function stopRecordAudio(){
    $("#voiceImg").attr("src","./images/duanxian/voice_stop.gif");
	clearInterval(recInterval);
	recInterval = null; 
	mediaRec.stopRecord();
	mediaRec.release();
	mediaRec=null;
	$("#voice_stopRecord").css("display","none");
	$("#voice_Play").css("display","block");
	$("#voice_stop").css("display","none");
	$("#voice_delete").css("display","block");
	$("#voice_cancel").css("display","block");
	$("#voice_ok").css("display","block");
}
function startPlayAudio(){
    $("#voiceImg").attr("src","./images/duanxian/voice.gif");
    $("#processbar").width(1);
	mediaRec = new Media(src,onmediaSuccess, onmediaError); 
	recInterval = setInterval(function(){
		mediaLength = mediaRec.getDuration();
		mediaRec.getCurrentPosition(function(position){
		    var processbarLength = processbgLength*position/mediaLength;
			$("#processbar").width(processbarLength);
			if(position<0){
				stopPlayAudio();
			}
		},function(e){
			console.log("Error getting pos=" + e);
		});
	},1000);
	mediaRec.play(); 
	$("#voice_stopRecord").css("display","none");
	$("#voice_Play").css("display","none");
	$("#voice_stop").css("display","block");
	$("#voice_delete").css("display","none");
	$("#voice_cancel").css("display","none");
	$("#voice_ok").css("display","none");
}
function stopPlayAudio(){
    $("#voiceImg").attr("src","./images/duanxian/voice_stop.gif");
	clearInterval(recInterval); 
	recInterval = null; 
	mediaRec.stop();
	mediaRec.release();
	mediaRec=null;
	$("#voice_stopRecord").css("display","none");
	$("#voice_Play").css("display","block");
	$("#voice_stop").css("display","none");
	$("#voice_delete").css("display","block");
	$("#voice_cancel").css("display","block");
	$("#voice_ok").css("display","block");
}
function cancelAudio(){
	hidevoicebox();
}
function okAudio(){
    isrecord=1;
	var vlth = voiceTimer*2+29;
	var voiceHTML = "<span class=\"voiceLRcls\"><img src=\".\/images\/voicebar_01.gif\"><\/span><span class=\"voiceMcls\" style=\"width:"+vlth+"px;\"><img src=\".\/images\/voicebar_stop.gif\"><\/span><span class=\"voiceLRcls\"><img src=\".\/images\/voicebar_03.gif\"><\/span><span class=\"voiceSeccls\">"+voiceTimer+"秒<\/span>"
	$("#voiceBox").html(voiceHTML);
	hidevoicebox();
}
function deleteAudio(){
    isrecord=0;
	$("#voiceBox").html("加入语音");
	hidevoicebox();
}

function cancelReply(){
	isrecord=0;
	hidevoicebox();
}
function recordreplyVoice(){
	startRecordAudio();
	isrecord=1;
}
function tovoiceReply(){
	hidecommentbox();
	$("#voiceImg").attr("src","./images/duanxian/mic_stop.gif");
	$("#voice_Record").css("display","block");
	$("#voice_stopRecord").css("display","none");
	$("#voice_Play").css("display","none");
	$("#voice_stop").css("display","none");
	$("#voice_delete").css("display","block");
	$("#voice_ok").css("display","none");
	$("#voice_cancel").css("display","block");
	showvoicebox();
}
function totxtReply(){
	isrecord=0;
	hidevoicebox();
	showcommentbox();
}
// 创建Media对象成功后调用的回调函数 
function onmediaSuccess() { 
	console.log("recordAudio():Audio Success"); 
	//alert("recordAudio():Audio Success"); 
} 
 
// 创建Media对象出错后调用的回调函数 
function onmediaError(error) { 
	console.log('code:' + error.code + '\n' + 'message:' + error.message + '\n'); 
	//alert('code:' + error.code + '\n' + 'message:' + error.message + '\n'); 
} 


/////////////////////////////////////////////////////////////////////////
//BBS相关的语音图片下载
/////////////////////////////////////////////////////////////////////////
function playgubavoice(Vid){
    if(mediabbs==null){
		playingvoiceBar = "vbar_"+Vid;
		$("#"+playingvoiceBar).attr("src","./css/images/ajax-loader.gif");
		downloadVoice("voice",Vid);
	}else{
		stopgubavoice();
		if(playingvoiceBar!="vbar_"+Vid){
			playgubavoice(Vid);
		}
	}
}
function playgubadetailvoice(Vid){
    if(mediabbs==null){
		playingvoiceBar = "vbar";
		$("#"+playingvoiceBar).attr("src","./css/images/ajax-loader.gif");
		downloadVoice("voice",Vid);
	}else{
		stopgubavoice();
		if(playingvoiceBar!="vbar"){
			playgubadetailvoice(Vid);
		}
	}
}
function playgubareplyvoice(Rid){
    if(mediabbs==null){
		playingvoiceBar = "vreplybar_"+Rid;
		$("#"+playingvoiceBar).attr("src","./css/images/ajax-loader.gif");
		downloadVoice("reply",Rid);
	}else{
		stopgubavoice();
		if(playingvoiceBar!="vreplybar_"+Rid){
			playgubareplyvoice(Rid);
		}
	}
}

function playtargetvoice(targetUrl){
	mediabbs = new Media(targetUrl);
	$("#"+playingvoiceBar).attr("src","./images/duanxian/voicebar.gif");
	bbsInterval = setInterval(function(){
		mediaLength = mediabbs.getDuration();
		mediabbs.getCurrentPosition(function(position){
			if(position<0){
				stopgubavoice();
			}
		},function(e){
			console.log("Error getting pos=" + e);
		});
	},1000);
	mediabbs.play();
}

function stopgubavoice(){
    $("#"+playingvoiceBar).attr("src","./images/duanxian/voicebar_stop.gif");
	clearInterval(bbsInterval); 
	mediabbs.stop();
	mediabbs.release();
	mediabbs=null;
	bbsInterval = null;
}
function downloadVoice(kindStr,Vid){
	var fileSystem;
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fs){   
		 fileSystem = fs;
		 //创建目录  
		 fileSystem.root.getDirectory("/sdcard/niumowang/gubavoice", {create:true,exclusive:false},   
			function(fileEntry){ 
				 var dirPath = fileEntry.fullPath;  
				 var _localFile = "/sdcard/niumowang/gubavoice/"+kindStr+"_"+Vid+".mp3";
				 var _url = serverURL+"/voice/"+kindStr+"_"+Vid+".mp3"; 
				 //查找文件  
				 fileSystem.root.getFile(_localFile, null, function(fileEntry){
					 playtargetvoice(_localFile);
				 }, function(){    
					 //否则就到网络下载图片!  
					 fileSystem.root.getFile(_localFile, {create:true,exclusive:false}, function(fileEntry){  
						var targetURL = fileEntry.toURL();
						var fileTransfer = new FileTransfer();   
						fileTransfer.download(_url,targetURL,function(entry){       
							playtargetvoice(targetURL);
						},function(error){
							$("#"+playingvoiceBar).attr("src","./images/duanxian/voicebar_stop.gif");
						});  
					 },function(){});   
				});  
			},function(){  
				//alert('创建目录失败');  
				//goTo("default.html");
		});  
	 }, function(evt){  
		//alert("加载文件系统出现错误");
		//goTo("default.html");
	});   
}

//function DoFile(yimage,fname){
//	var dirname = "/sdcard/meilizhi";  //目标路径
//	var ismove=true;//定义为移动
//	//开始操作文件
//	//通过本地URI参数检索DirectoryEntry或FileEntry
//	window.resolveLocalFileSystemURI(yimage,function(fileEntry){
//	//请求持久化的文件系统
//		window.requestFileSystem(LocalFileSystem.PERSISTENT,0,function(fileSystem){
//			//如果目录不存在就创建
//			var direc = fileSystem.root.getDirectory(dirname, {create:true},function(parent){
//				alert("Parent Name:" + parent.name +"<br/>Full Path:"+ parent.fullPath);
//				//移动文件
//				if(ismove){
//					fileEntry.moveTo(parent,fname,function(){
//						alert("Move OK: "+ parent.fullPath +"/"+ fname );
//						var largeImage = document.getElementById('smallImage_'+picNum);
//						largeImage.src = parent.fullPath +"/"+ fname;
//					}, onFileFail);
//				}else{
//					//复制文件
//					fileEntry.copyTo(parent, fname,function(){
//						toLog("Copy OK: "+ parent.fullPath +"/"+ fname );
//					}, onFileFail);
//				}//end if
//			},onFileFail);
//		}, onFileFail); 
//	},onFileFail);
//}
